#include <bits/stdc++.h>

using namespace std;



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t, n,k;
    cin>> t >> n >>k;
    vector<int> v(n);
    for(int i=0; i<n; i++){
        int a; cin >> a;
        v[i]=a;
    }

    int kontr=0;
    for (int i=0; i<n; i++){
        if(v[i]>kontr)
            kontr--;
        else
            kontr++;
    }
    if(t==0) cout << "DA";
    else {cout << "DA" << '\n';
        for (int i=0; i<n; i++)
        cout << v[i] << ' ';
    }
    return 0;
}